/*********************************************************************************
// AVR 3D Graphics Library created by Timo Birnschein
// Mail: timo.birnschein@web.de
// Web: http://erfinderdesautos.de
// 
// Code partly based on the code from
// (c) 2.2002   Holger Buss  Germany
// mailto:buss@mikrocontroller.com
// http://www.mikrocontroller.com
*********************************************************************************/

#ifndef __AVR_GL__
#define __AVR_GL__

#include "t6963c.h"
#include "types.h"

#define     MUL 256      // because of fixcomma-calculations

int 	glRotationMatrix[4][4];
int 	glRotationVector[3];
int 	glTranslationVector[3];
int 	glScaleVector[3];

typedef union vertexBuffer {
	int8	x;
	int8	y;
	int8	z;
}vertexBuffer;

void glLoadIdentity(void);
void glTranslate3i(int8 x, int8 y, int8 z);
void glRotate3i(int8 x, int8 y, int8 z);
void glScale3i(int8 x, int8 y, int8 z);
void glFlush(void); // Shurely not not never used... :P
void glClear(void);

void glVertex(int8 posX, int8 posY, int8 posZ, uint8 show);
void glLine(int8 posX, int8 posY, int8 posZ, int8 posX2, int8 posY2, int8 posZ2, uint8 show);
void glTriangle(vertexBuffer vertex1, vertexBuffer vertex2, vertexBuffer vertex3, uint8 show);

void glPyramid(int8 posX, int8 posY, int8 sizeX, int8 sizeY, uint8 show);
void glQuad(int8 posX, int8 posY, int8 sizeX, int8 sizeY, uint8 show);
void glCube(int8 posX, int8 posY, int8 posZ, int8 sizeX, int8 sizeY, int8 sizeZ, uint8 show);
void glSphere(int8 posX, int8 posY, int8 posZ, int8 radius, int8 resolution, uint8 show);


#endif
